Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml	(revision 5459)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml	(revision 5478)
@@ -36,5 +36,4 @@
       <Column Name="Name" Type="System.String" DbType="NVarChar(200) NOT NULL" CanBeNull="false" />
       <Column Name="Description" Type="System.String" DbType="NVarChar(MAX)" CanBeNull="true" />
-      <Association Name="Platform_DataType" Member="DataTypes" ThisKey="Id" OtherKey="PlatformId" Type="DataType" />
       <Association Name="Platform_Algorithm" Member="Algorithms" ThisKey="Id" OtherKey="PlatformId" Type="Algorithm" />
       <Association Name="Platform_Problem" Member="Problems" ThisKey="Id" OtherKey="PlatformId" Type="Problem" />
@@ -44,5 +43,4 @@
     <Type Name="DataType">
       <Column Name="Id" Type="System.Int64" DbType="BigInt NOT NULL IDENTITY" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" />
-      <Column Name="PlatformId" Type="System.Int64" DbType="BigInt NOT NULL" CanBeNull="false" />
       <Column Name="Name" Type="System.String" DbType="NVarChar(200) NOT NULL" CanBeNull="false" />
       <Column Name="TypeName" Type="System.String" DbType="NVarChar(MAX) NOT NULL" CanBeNull="false" />
@@ -51,5 +49,4 @@
       <Association Name="DataType_Value" Member="Values" ThisKey="Id" OtherKey="DataTypeId" Type="Value" />
       <Association Name="DataType_CharacteristicValue" Member="CharacteristicValues" ThisKey="Id" OtherKey="DataTypeId" Type="CharacteristicValue" />
-      <Association Name="Platform_DataType" Member="Platform" ThisKey="PlatformId" OtherKey="Id" Type="Platform" IsForeignKey="true" />
     </Type>
   </Table>
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml.layout
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml.layout	(revision 5459)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml.layout	(revision 5478)
@@ -33,17 +33,10 @@
       </nestedChildShapes>
     </classShape>
-    <classShape Id="34f5a12b-f109-4606-baf8-6ddfde7c1b34" absoluteBounds="7, 2.125, 2, 1.5785953776041666">
+    <classShape Id="34f5a12b-f109-4606-baf8-6ddfde7c1b34" absoluteBounds="7, 2.125, 2, 1.3862939453125">
       <DataClassMoniker Name="/OKBDataContext/DataType" />
       <nestedChildShapes>
-        <elementListCompartment Id="1dacac40-e283-48e9-a98d-dddbc6b4fd48" absoluteBounds="7.0150000000000006, 2.585, 1.9700000000000002, 1.0185953776041665" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
-      </nestedChildShapes>
-    </classShape>
-    <associationConnector edgePoints="[(8 : 1.8862939453125); (8 : 2.125)]" fixedFrom="NotFixed" fixedTo="NotFixed">
-      <AssociationMoniker Name="/OKBDataContext/Platform/Platform_DataType" />
-      <nodes>
-        <classShapeMoniker Id="42a9e8c0-3168-43f0-a31f-54d1558bd4c2" />
-        <classShapeMoniker Id="34f5a12b-f109-4606-baf8-6ddfde7c1b34" />
-      </nodes>
-    </associationConnector>
+        <elementListCompartment Id="1dacac40-e283-48e9-a98d-dddbc6b4fd48" absoluteBounds="7.0150000000000006, 2.585, 1.9700000000000002, 0.8262939453125" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+      </nestedChildShapes>
+    </classShape>
     <classShape Id="c75911bf-ae6d-421c-9219-e027c3059390" absoluteBounds="3.5, 4, 2, 1.5785953776041666">
       <DataClassMoniker Name="/OKBDataContext/ValueName" />
@@ -58,5 +51,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(2.75 : 2.39024983723958); (2.5 : 2.39024983723958)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(2.75 : 2.39024983723958); (2.5 : 2.39024983723958)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/OKBDataContext/Algorithm/Algorithm_AlgorithmUser" />
       <nodes>
@@ -72,5 +65,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(7 : 2.39024983723958); (4.75 : 2.39024983723958)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(7 : 2.39024983723958); (4.75 : 2.39024983723958)]" fixedFrom="Algorithm" fixedTo="Algorithm">
       <AssociationMoniker Name="/OKBDataContext/DataType/DataType_Algorithm" />
       <nodes>
@@ -92,5 +85,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(13.25 : 2.39024983723958); (13.5 : 2.39024983723958)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(13.25 : 2.39024983723958); (13.5 : 2.39024983723958)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/OKBDataContext/Problem/Problem_ProblemUser" />
       <nodes>
@@ -99,5 +92,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(9 : 2.39024983723958); (11.25 : 2.39024983723958)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(9 : 2.39024983723958); (11.25 : 2.39024983723958)]" fixedFrom="Algorithm" fixedTo="Algorithm">
       <AssociationMoniker Name="/OKBDataContext/DataType/DataType_Problem" />
       <nodes>
@@ -126,5 +119,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(7 : 10.3181469726562); (2.98333686713063 : 10.3181469726562); (2.98333686713063 : 2.65549967447917)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(7 : 10.3181469726562); (2.98333686713063 : 10.3181469726562); (2.98333686713063 : 2.65549967447917)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/OKBDataContext/BinaryData/BinaryData_Algorithm" />
       <nodes>
@@ -133,5 +126,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(9 : 10.3181469726562); (13.0131477507419 : 10.3181469726562); (13.0131477507419 : 2.65549967447917)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(9 : 10.3181469726562); (13.0131477507419 : 10.3181469726562); (13.0131477507419 : 2.65549967447917)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/OKBDataContext/BinaryData/BinaryData_Problem" />
       <nodes>
@@ -173,5 +166,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(7 : 3.07568669800201); (6.6959048132675 : 3.07568669800201); (6.6959048132675 : 4)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(7.273878302532 : 3.5112939453125); (7.273878302532 : 4)]" fixedFrom="Caller" fixedTo="Algorithm">
       <AssociationMoniker Name="/OKBDataContext/DataType/DataType_Value" />
       <nodes>
@@ -213,5 +206,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(9 : 3.05278498857512); (9.24152226977744 : 3.05278498857512); (9.24152226977744 : 4)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(8.68784173221247 : 3.5112939453125); (8.68784173221247 : 4)]" fixedFrom="Caller" fixedTo="Algorithm">
       <AssociationMoniker Name="/OKBDataContext/DataType/DataType_CharacteristicValue" />
       <nodes>
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.designer.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.designer.cs	(revision 5459)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.designer.cs	(revision 5478)
@@ -760,6 +760,4 @@
 		private string _Description;
 		
-		private EntitySet<DataType> _DataTypes;
-		
 		private EntitySet<Algorithm> _Algorithms;
 		
@@ -780,5 +778,4 @@
 		public Platform()
 		{
-			this._DataTypes = new EntitySet<DataType>(new Action<DataType>(this.attach_DataTypes), new Action<DataType>(this.detach_DataTypes));
 			this._Algorithms = new EntitySet<Algorithm>(new Action<Algorithm>(this.attach_Algorithms), new Action<Algorithm>(this.detach_Algorithms));
 			this._Problems = new EntitySet<Problem>(new Action<Problem>(this.attach_Problems), new Action<Problem>(this.detach_Problems));
@@ -846,17 +843,4 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Platform_DataType", Storage="_DataTypes", ThisKey="Id", OtherKey="PlatformId")]
-		public EntitySet<DataType> DataTypes
-		{
-			get
-			{
-				return this._DataTypes;
-			}
-			set
-			{
-				this._DataTypes.Assign(value);
-			}
-		}
-		
 		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Platform_Algorithm", Storage="_Algorithms", ThisKey="Id", OtherKey="PlatformId")]
 		public EntitySet<Algorithm> Algorithms
@@ -903,16 +887,4 @@
 				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
 			}
-		}
-		
-		private void attach_DataTypes(DataType entity)
-		{
-			this.SendPropertyChanging();
-			entity.Platform = this;
-		}
-		
-		private void detach_DataTypes(DataType entity)
-		{
-			this.SendPropertyChanging();
-			entity.Platform = null;
 		}
 		
@@ -950,6 +922,4 @@
 		private long _Id;
 		
-		private long _PlatformId;
-		
 		private string _Name;
 		
@@ -963,6 +933,4 @@
 		
 		private EntitySet<CharacteristicValue> _CharacteristicValues;
-		
-		private EntityRef<Platform> _Platform;
 		
     #region Extensibility Method Definitions
@@ -972,6 +940,4 @@
     partial void OnIdChanging(long value);
     partial void OnIdChanged();
-    partial void OnPlatformIdChanging(long value);
-    partial void OnPlatformIdChanged();
     partial void OnNameChanging(string value);
     partial void OnNameChanged();
@@ -986,5 +952,4 @@
 			this._Values = new EntitySet<Value>(new Action<Value>(this.attach_Values), new Action<Value>(this.detach_Values));
 			this._CharacteristicValues = new EntitySet<CharacteristicValue>(new Action<CharacteristicValue>(this.attach_CharacteristicValues), new Action<CharacteristicValue>(this.detach_CharacteristicValues));
-			this._Platform = default(EntityRef<Platform>);
 			OnCreated();
 		}
@@ -1010,28 +975,4 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_PlatformId", DbType="BigInt NOT NULL")]
-		public long PlatformId
-		{
-			get
-			{
-				return this._PlatformId;
-			}
-			set
-			{
-				if ((this._PlatformId != value))
-				{
-					if (this._Platform.HasLoadedOrAssignedValue)
-					{
-						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
-					}
-					this.OnPlatformIdChanging(value);
-					this.SendPropertyChanging();
-					this._PlatformId = value;
-					this.SendPropertyChanged("PlatformId");
-					this.OnPlatformIdChanged();
-				}
-			}
-		}
-		
 		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="NVarChar(200) NOT NULL", CanBeNull=false)]
 		public string Name
@@ -1123,38 +1064,4 @@
 			{
 				this._CharacteristicValues.Assign(value);
-			}
-		}
-		
-		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Platform_DataType", Storage="_Platform", ThisKey="PlatformId", OtherKey="Id", IsForeignKey=true)]
-		public Platform Platform
-		{
-			get
-			{
-				return this._Platform.Entity;
-			}
-			set
-			{
-				Platform previousValue = this._Platform.Entity;
-				if (((previousValue != value) 
-							|| (this._Platform.HasLoadedOrAssignedValue == false)))
-				{
-					this.SendPropertyChanging();
-					if ((previousValue != null))
-					{
-						this._Platform.Entity = null;
-						previousValue.DataTypes.Remove(this);
-					}
-					this._Platform.Entity = value;
-					if ((value != null))
-					{
-						value.DataTypes.Add(this);
-						this._PlatformId = value.Id;
-					}
-					else
-					{
-						this._PlatformId = default(long);
-					}
-					this.SendPropertyChanged("Platform");
-				}
 			}
 		}