Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 5490)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 5491)
@@ -113,18 +113,18 @@
     <Compile Include="Interfaces\IDataAnalysisSolution.cs" />
     <Compile Include="Interfaces\IDataAnalysisSolutionCreator.cs" />
+    <Compile Include="Interfaces\IOnlineEvaluator.cs" />
+    <Compile Include="OnlineEvaluators\OnlineCovarianceEvaluator.cs" />
+    <Compile Include="OnlineEvaluators\OnlineMeanAbsolutePercentageErrorEvaluator.cs" />
+    <Compile Include="OnlineEvaluators\OnlineMeanAndVarianceCalculator.cs" />
+    <Compile Include="OnlineEvaluators\OnlineMeanSquaredErrorEvaluator.cs" />
+    <Compile Include="OnlineEvaluators\OnlineNormalizedMeanSquaredErrorEvaluator.cs" />
+    <Compile Include="OnlineEvaluators\OnlinePearsonsRSquaredEvaluator.cs" />
     <Compile Include="TableFileParser.cs" />
     <None Include="HeuristicLab.snk" />
     <None Include="HeuristicLabProblemsDataAnalysisPlugin.cs.frame" />
     <None Include="Properties\AssemblyInfo.frame" />
-    <Compile Include="Online Evaluators\OnlineCovarianceEvaluator.cs" />
-    <Compile Include="Online Evaluators\OnlineMeanAndVarianceCalculator.cs" />
-    <Compile Include="Online Evaluators\OnlineNormalizedMeanSquaredErrorEvaluator.cs" />
-    <Compile Include="Online Evaluators\OnlineMeanAbsolutePercentageErrorEvaluator.cs" />
-    <Compile Include="Online Evaluators\OnlineMeanSquaredErrorEvaluator.cs" />
-    <Compile Include="Online Evaluators\OnlinePearsonsRSquaredEvaluator.cs" />
     <Compile Include="HeuristicLabProblemsDataAnalysisPlugin.cs" />
     <Compile Include="Interfaces\IDataAnalysisModel.cs" />
     <Compile Include="Interfaces\IDataAnalysisProblem.cs" />
-    <Compile Include="Online Evaluators\IOnlineEvaluator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineCovarianceEvaluator.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineCovarianceEvaluator.cs	(revision 5490)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineCovarianceEvaluator.cs	(revision 5491)
@@ -22,5 +22,5 @@
 using System;
 
-namespace HeuristicLab.Problems.DataAnalysis.Evaluators {
+namespace HeuristicLab.Problems.DataAnalysis {
   public class OnlineCovarianceEvaluator : IOnlineEvaluator {
 
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineMeanAbsolutePercentageErrorEvaluator.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineMeanAbsolutePercentageErrorEvaluator.cs	(revision 5490)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineMeanAbsolutePercentageErrorEvaluator.cs	(revision 5491)
@@ -23,5 +23,5 @@
 using HeuristicLab.Common;
 
-namespace HeuristicLab.Problems.DataAnalysis.Evaluators {
+namespace HeuristicLab.Problems.DataAnalysis {
   public class OnlineMeanAbsolutePercentageErrorEvaluator : IOnlineEvaluator {
 
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineMeanAndVarianceCalculator.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineMeanAndVarianceCalculator.cs	(revision 5490)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineMeanAndVarianceCalculator.cs	(revision 5491)
@@ -22,5 +22,5 @@
 using System;
 
-namespace HeuristicLab.Problems.DataAnalysis.Evaluators {
+namespace HeuristicLab.Problems.DataAnalysis {
   public class OnlineMeanAndVarianceCalculator {
 
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineMeanSquaredErrorEvaluator.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineMeanSquaredErrorEvaluator.cs	(revision 5490)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineMeanSquaredErrorEvaluator.cs	(revision 5491)
@@ -22,5 +22,5 @@
 using System;
 
-namespace HeuristicLab.Problems.DataAnalysis.Evaluators {
+namespace HeuristicLab.Problems.DataAnalysis {
   public class OnlineMeanSquaredErrorEvaluator : IOnlineEvaluator {
 
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineNormalizedMeanSquaredErrorEvaluator.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineNormalizedMeanSquaredErrorEvaluator.cs	(revision 5490)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/OnlineEvaluators/OnlineNormalizedMeanSquaredErrorEvaluator.cs	(revision 5491)
@@ -22,5 +22,5 @@
 using System;
 
-namespace HeuristicLab.Problems.DataAnalysis.Evaluators {
+namespace HeuristicLab.Problems.DataAnalysis {
   public class OnlineNormalizedMeanSquaredErrorEvaluator : IOnlineEvaluator {
     private OnlineMeanAndVarianceCalculator meanSquaredErrorCalculator;