Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 5502)
@@ -134,8 +134,7 @@
     <Compile Include="Authentication\DataTransfer\User.cs" />
     <Compile Include="Authentication\IAuthenticationService.cs" />
-    <Compile Include="Convert.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Query\Convert.cs" />
     <Compile Include="Query\DataTransfer\Algorithm.cs" />
-    <Compile Include="Query\DataTransfer\AlgorithmClass.cs" />
     <Compile Include="Query\DataTransfer\BinaryValue.cs" />
     <Compile Include="Query\DataTransfer\BooleanOperation.cs" />
@@ -163,7 +162,5 @@
     <Compile Include="Query\DataTransfer\OrdinalComparisonIntFilter.cs" />
     <Compile Include="Query\DataTransfer\OrdinalComparisonLongFilter.cs" />
-    <Compile Include="Query\DataTransfer\Platform.cs" />
     <Compile Include="Query\DataTransfer\Problem.cs" />
-    <Compile Include="Query\DataTransfer\ProblemClass.cs" />
     <Compile Include="Query\DataTransfer\Run.cs" />
     <Compile Include="Query\DataTransfer\StringComparison.cs" />
@@ -175,37 +172,24 @@
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="Query\Filters\AlgorithmDataDataTypeNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Query\Filters\AlgorithmNameFilter.cs">
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterBlobValueDataTypeNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterBlobValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterBoolValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterFloatValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterIntValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmParameterStringValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\AlgorithmPlatformNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Query\Filters\AndFilter.cs">
       <SubType>Code</SubType>
     </Compile>
+    <Compile Include="Query\Filters\AlgorithmDataTypeNameFilter.cs" />
+    <Compile Include="Query\Filters\AlgorithmPlatformNameFilter.cs" />
+    <Compile Include="Query\Filters\BoolValueFilter.cs" />
+    <Compile Include="Query\Filters\BinaryValueFilter.cs" />
+    <Compile Include="Query\Filters\StringValueFilter.cs" />
+    <Compile Include="Query\Filters\FloatValueFilter.cs" />
+    <Compile Include="Query\Filters\DoubleValueFilter.cs" />
+    <Compile Include="Query\Filters\LongValueFilter.cs" />
+    <Compile Include="Query\Filters\IntValueFilter.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Query\Filters\ValueDataTypeNameFilter.cs" />
+    <Compile Include="Query\Filters\ProblemPlatformNameFilter.cs" />
+    <Compile Include="Query\Filters\ProblemDataTypeNameFilter.cs" />
     <Compile Include="Query\Filters\IFilter.cs" />
     <Compile Include="Query\Filters\OrFilter.cs">
@@ -215,55 +199,7 @@
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="Query\Filters\ProblemDataDataTypeNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Query\Filters\ProblemNameFilter.cs">
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="Query\Filters\ProblemParameterBlobValueDataTypeNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterBlobValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterBoolValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterFloatValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterIntValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemParameterStringValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ProblemPlatformNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultBlobValueDataTypeNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultBlobValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultBoolValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultFloatValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultIntValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultNameFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Query\Filters\ResultStringValueValueFilter.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Query\Filters\RunClientNameFilter.cs">
       <SubType>Code</SubType>
@@ -278,6 +214,11 @@
       <SubType>Code</SubType>
     </Compile>
+    <Compile Include="Query\Filters\ValueNameFilter.cs">
+      <SubType>Code</SubType>
+    </Compile>
     <Compile Include="Query\IQueryService.cs" />
-    <Compile Include="Query\QueryService.cs" />
+    <Compile Include="Query\QueryService.cs">
+      <SubType>Code</SubType>
+    </Compile>
     <Compile Include="RunCreation\Convert.cs" />
     <Compile Include="RunCreation\DataTransfer\Algorithm.cs" />
@@ -310,8 +251,4 @@
       <Name>HeuristicLab.Services.OKB.DataAccess-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Services.OKB.DataTransfer\3.3\HeuristicLab.Services.OKB.DataTransfer-3.3.csproj">
-      <Project>{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}</Project>
-      <Name>HeuristicLab.Services.OKB.DataTransfer-3.3</Name>
-    </ProjectReference>
   </ItemGroup>
   <ItemGroup />